-----------------------------------------------------------------------------------------------
-- Client Lua Script for Itemlink
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- Itemlink Module Definition
-----------------------------------------------------------------------------------------------
local Itemlink = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function Itemlink:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function Itemlink:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- Itemlink OnLoad
-----------------------------------------------------------------------------------------------
function Itemlink:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("Itemlink.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	
	self.itemlist = {}
	local i = 1
	while i <= 65535 do
	if Item.GetDataFromId(i) then
	self.itemlist[i] = Item.GetDataFromId(i):GetName():lower()
	end
	i = i + 1
	end
	
end

-----------------------------------------------------------------------------------------------
-- Itemlink OnDocLoaded
-----------------------------------------------------------------------------------------------
function Itemlink:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "ItemlinkForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("item", "OnItemlinkOn", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- Itemlink Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/item"
function Itemlink:OnItemlinkOn(command, itemn)

	itemn = itemn:lower()	
	
	local i = 1	
	local j = false
	local starting = 1000
	local length = 1000
	local chati = 0
	local a = 0
	local b = 0
	
	while i <= 65535 do
	
		if self.itemlist[i] then
			if string.find(self.itemlist[i], itemn) then
				a, b = string.find(self.itemlist[i], itemn)
				if a <= starting then
					if a < starting then
						chati = i
						length = string.len(self.itemlist[i])
						starting = string.find(self.itemlist[i], itemn)
					else
						if string.len(self.itemlist[i]) < length then
							chati = i
							length = string.len(self.itemlist[i])
							starting = string.find(self.itemlist[i], itemn)
						end
					end
				end
				j = true
			end	
		end		
		i = i + 1	
	end
	
	if j == false then
		Print("Could not find item.")
	else
			-- Thanks to Tanerinn for this line
		local ch = Apollo.FindWindowByName("ChatWindow"):GetData().channelCurrent:GetCommand()
		
		-- The principle for this is copied from Rare Tracker
		for _,channel in pairs(ChatSystemLib.GetChannels()) do
         	if channel:GetCommand():lower() == ch then
            	channel:Send(Item.GetDataFromId(chati):GetChatLinkString())
          	end
        end
	end
	
end


-----------------------------------------------------------------------------------------------
-- ItemlinkForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function Itemlink:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function Itemlink:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- Itemlink Instance
-----------------------------------------------------------------------------------------------
local ItemlinkInst = Itemlink:new()
ItemlinkInst:Init()
